package prova.med.NFCutils;

import java.io.IOException;
import java.nio.charset.Charset;
import java.util.Locale;

import android.nfc.NdefMessage;
import android.nfc.NdefRecord;
import android.nfc.Tag;
import android.nfc.tech.Ndef;
import android.nfc.tech.NdefFormatable;

public class NFCwriting {

	public static final String successo = "Scrittura riuscita";
	
	static public NdefRecord createRecord(String string_to_write)
	{
		Locale locale= new Locale("it","IT");
		byte[] langBytes = locale.getLanguage().getBytes(Charset.forName("UTF-8"));
		boolean encodeInUtf8=false;
		Charset utfEncoding = encodeInUtf8 ? Charset.forName("UTF-8") :	Charset.forName("UTF-16");
		int utfBit = encodeInUtf8 ? 0 : (1 << 7);
		char status = (char) (utfBit + langBytes.length);
		byte[] textBytes = string_to_write.getBytes(utfEncoding);
		byte[] data = new byte[1 + langBytes.length + textBytes.length];
		data[0] = (byte) status;
		System.arraycopy(langBytes, 0, data, 1, langBytes.length);
		System.arraycopy(textBytes, 0, data, 1 + langBytes.length, textBytes.length);
		NdefRecord textRecord = new NdefRecord(NdefRecord.TNF_WELL_KNOWN, NdefRecord.RTD_TEXT, new byte[0], data);
		return textRecord;
	}
	
	static public String writeNdefMessageToTag(NdefMessage message, Tag detectedTag) {
		int size = message.toByteArray().length;
		
		try {
			Ndef ndef = Ndef.get(detectedTag);
			if (ndef != null) {
				ndef.connect();
				if (!ndef.isWritable()) {
					return "Il tag  read-only";
				}
				if (ndef.getMaxSize() < size) {
					return "Spazio insufficiente, la capacit  " + ndef.getMaxSize() + " bytes, il messaggio  " + size + " bytes";
					
				}
				ndef.writeNdefMessage(message);
				ndef.close();
				return successo;
			} else {
				NdefFormatable ndefFormat = NdefFormatable.get(detectedTag);
				if (ndefFormat != null) {
					try {
						ndefFormat.connect();
						ndefFormat.format(message);
						ndefFormat.close();
						return successo;
					} catch (IOException e) {
						return "Formattazione fallita";
					}
				} else {
					return "NDEF non supportato";
				}
			}
		} catch (Exception e) {
			return "Operazione di scrittura fallita";
		}
	}

}