package prova.med.activities;

import prova.med.boris.R;
import prova.med.db.PazientiDBAdapter;
import prova.med.obj.Paziente;
import android.os.Bundle;
import android.app.Activity;
import android.content.Intent;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.support.v4.app.NavUtils;

public class ModificaPaziente extends Activity {

	private Paziente paziente;
	private PazientiDBAdapter datasource;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		//riutilizzo layout nuovo paziente
		setContentView(R.layout.activity_nuovo_paziente);
		
		//riempio i campi con i dati presenti
		Intent intent = getIntent();
		paziente = (Paziente) intent.getSerializableExtra(getString(R.string.IntentPaziente));
		findViewById(R.id.LayoutCodiceBarre).setVisibility(View.GONE);
		fillView();
		
		datasource = new PazientiDBAdapter(getApplicationContext());
		datasource.open();
		// Show the Up button in the action bar.
		setupActionBar();
	}

	/**
	 * Set up the {@link android.app.ActionBar}.
	 */
	private void setupActionBar() {

		getActionBar().setDisplayHomeAsUpEnabled(true);

	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.modifica_paziente, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case android.R.id.home:
			// This ID represents the Home or Up button. In the case of this
			// activity, the Up button is shown. Use NavUtils to allow users
			// to navigate up one level in the application structure. For
			// more details, see the Navigation pattern on Android Design:
			//
			// http://developer.android.com/design/patterns/navigation.html#up-vs-back
			//
			NavUtils.navigateUpFromSameTask(this);
			return true;
		}
		return super.onOptionsItemSelected(item);
	}
	
	//metodo privato --- setta la view con gli attributi del paziente
	private void fillView()
	{
		//Editext
		if(paziente.getNome() != null)
			((EditText) findViewById(R.id.EditTextNome)).setText(paziente.getNome());
		if(paziente.getCognome() != null)
			((EditText) findViewById(R.id.EditTextCognome)).setText(paziente.getCognome());
		if(paziente.getData_di_ingresso() != null && !paziente.getData_di_ingresso().isEmpty())
			((Button) findViewById(R.id.ButtonDataDiIngresso)).setText(paziente.getData_di_ingresso());
		if(paziente.getNumero_letto() != null)
			((EditText) findViewById(R.id.EditTextNumeroLetto)).setText(paziente.getNumero_letto());
		if(paziente.getCodice_diagnosi() != null)
			((EditText) findViewById(R.id.EditTextCodDiagnosi)).setText(paziente.getCodice_diagnosi());
		if(paziente.getCodice_intervento() != null)
			((EditText) findViewById(R.id.EditTextCodIntervento)).setText(paziente.getCodice_intervento());
		if(paziente.getPatologia() != null)
			((EditText) findViewById(R.id.EditTextPatologia)).setText(paziente.getPatologia());
		if(paziente.getCodice_a_barre() != null)
			((EditText) findViewById(R.id.EditTextCodiceBarre)).setText(paziente.getCodice_a_barre());
		if(paziente.getAnni() != null)
			((EditText) findViewById(R.id.EditTextAnni)).setText(paziente.getAnni());
		if(paziente.getCreatinina() != null)
			((EditText) findViewById(R.id.EditTextCreatinina)).setText(paziente.getCreatinina());
		if(paziente.getAlt() != null)
			((EditText) findViewById(R.id.EditTextALT)).setText(paziente.getAlt());
		if(paziente.getAst() != null)
			((EditText) findViewById(R.id.EditTextAST)).setText(paziente.getAst());
		if(paziente.getAllergie_altro() != null && paziente.getAllergie().equals(getString(R.string.altro)))
			{
				EditText allergie_altro = (EditText) findViewById(R.id.EditTextAllergieAltro);
				allergie_altro.setText(paziente.getAllergie_altro());
				allergie_altro.setVisibility(View.VISIBLE);
			}
		
		//Spinner
		if(paziente.getPiano() != null)
			((Spinner) findViewById(R.id.SpinnerPiano)).setSelection(getIndex((Spinner) findViewById(R.id.SpinnerPiano),paziente.getPiano() ));
		if(paziente.getReparto() != null)
			((Spinner) findViewById(R.id.SpinnerReparto)).setSelection(getIndex((Spinner) findViewById(R.id.SpinnerReparto),paziente.getReparto() ));
		if(paziente.getAllergie() != null)
			((Spinner) findViewById(R.id.SpinnerAllergie)).setSelection(getIndex((Spinner) findViewById(R.id.SpinnerAllergie),paziente.getAllergie() ));
		
	}
	
	//metodo privato -- recupera l'attributo del paziente e restituisce l'indice relativo allo spinner
	private int getIndex(Spinner spinner, String string_select)
	 {
	  int index = 0;
	  for (int i=0;i<spinner.getCount();i++){
	   if (spinner.getItemAtPosition(i).toString().equalsIgnoreCase(string_select)){
	    index = i;
	    break;
	   }
	  }
	  return index;
	 } 

	public void procedi(View v)
	{
		v.setClickable(false);
		
		//recupero campi e aggiorno dati paziente
		update_paziente();

		//intent 
		Intent intent = new Intent(this, VisualizzaPazienti.class);
		
		intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP); 
	    intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
	    
	    v.setClickable(true);
		startActivity(intent);
	}
	
	private void update_paziente()
	{
		//Settare Stringhe vuote nel caso di campi vuoti
				paziente.setNome( ((EditText)findViewById(R.id.EditTextNome)).getText().toString().trim());
				paziente.setCognome( ((EditText)findViewById(R.id.EditTextCognome)).getText().toString().trim());

				String data_di_ingresso = ((Button)findViewById(R.id.ButtonDataDiIngresso)).getText().toString().trim();
				if (!data_di_ingresso.equals( getString(R.string.datadiingresso)))
					paziente.setData_di_ingresso(data_di_ingresso);
				else 
					paziente.setData_di_ingresso("");

				paziente.setNumero_letto(((EditText)findViewById(R.id.EditTextNumeroLetto)).getText().toString());
				paziente.setReparto( ((Spinner)findViewById(R.id.SpinnerReparto)).getSelectedItem().toString());
				paziente.setPiano( ((Spinner)findViewById(R.id.SpinnerPiano)).getSelectedItem().toString());

				String codice_diagnosi =  ((EditText)findViewById(R.id.EditTextCodDiagnosi)).getText().toString();
				if (codice_diagnosi != null)
					paziente.setCodice_diagnosi( codice_diagnosi);
				else
					paziente.setCodice_diagnosi("");

				String codice_intervento = ((EditText)findViewById(R.id.EditTextCodIntervento)).getText().toString();
				if (codice_intervento != null)
					paziente.setCodice_intervento(codice_intervento );
				else
					paziente.setCodice_intervento("");

				String patologia =((EditText)findViewById(R.id.EditTextPatologia)).getText().toString();
				if(patologia != null)
					paziente.setPatologia(patologia);
				else
					paziente.setPatologia("");

				paziente.setAllergie( ((Spinner)findViewById(R.id.SpinnerAllergie)).getSelectedItem().toString());
				if (paziente.getAllergie().equals(R.string.Nessuna))
					paziente.setAllergie_altro( ((EditText)findViewById(R.id.EditTextAllergieAltro)).getText().toString());

				paziente.setCodice_a_barre( ((EditText)findViewById(R.id.EditTextCodiceBarre)).getText().toString());

				String anni = ((EditText)findViewById(R.id.EditTextAnni)).getText().toString();
				if(anni != null)
					paziente.setAnni(anni);
				else 
					paziente.setAnni("");

				String alt = ((EditText)findViewById(R.id.EditTextALT)).getText().toString();
				if(alt != null)
					paziente.setAlt(alt);
				else
					paziente.setAlt("");

				String ast = ((EditText)findViewById(R.id.EditTextAST)).getText().toString();
				if(ast != null)
					paziente.setAst(ast);
				else 
					paziente.setAst("");

				String creatinina =  ((EditText)findViewById(R.id.EditTextCreatinina)).getText().toString();
				if(creatinina != null)
					paziente.setCreatinina(creatinina);
				else
					paziente.setCreatinina("");
				datasource.updatePaziente(paziente);
	}
	
	protected void onPause()
	{
		datasource.close();
	    super.onPause();
	}
	
	protected void onResume()
	{
		datasource.open();
		super.onResume();
	}
}

