package prova.med.activities;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.StringTokenizer;

import com.google.zxing.integration.android.*;

import prova.med.boris.R;
import prova.med.db.PazientiDBAdapter;
import prova.med.frag.DatePickerFragment;
import prova.med.obj.*;

import android.app.DatePickerDialog.OnDateSetListener;
import android.content.Intent;
import android.os.Bundle;
import android.support.v4.app.FragmentActivity;
import android.support.v4.app.NavUtils;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.Toast;

public class NuovoPaziente extends FragmentActivity {


	//protected TextView mDateDisplay;
	protected int lastClicked;
	private Paziente paziente;

	private EditText nome;
	private EditText cognome;
	private Button data_di_ingresso;
	private EditText numero_letto;
	private Spinner reparto;
	private Spinner piano;
	private EditText codice_diagnosi;
	private EditText codice_intervento;
	private EditText patologia;
	private Spinner allergie;
	private EditText allergie_altro;
	private EditText codice_barre;
	private EditText anni;
	private EditText alt;
	private EditText ast;
	private EditText creatinina;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_nuovo_paziente);
		// Show the Up button in the action bar.
		setupActionBar();

		//recupero paziente
		paziente = new Paziente();

		//ottengo un riferimento a tutte le view per non ripetere findview
		nome = (EditText) findViewById(R.id.EditTextNome);
		cognome = (EditText) findViewById(R.id.EditTextCognome);

		data_di_ingresso = (Button)findViewById(R.id.ButtonDataDiIngresso);
		SimpleDateFormat format = new SimpleDateFormat("dd/MM/yyyy");
		data_di_ingresso.setText(format.format(Calendar.getInstance().getTime()));

		numero_letto = (EditText)findViewById(R.id.EditTextNumeroLetto);
		reparto =	(Spinner)findViewById(R.id.SpinnerReparto);
		piano =	(Spinner)findViewById(R.id.SpinnerPiano);
		codice_diagnosi = (EditText)findViewById(R.id.EditTextCodDiagnosi);
		codice_intervento = (EditText)findViewById(R.id.EditTextCodIntervento);
		patologia = (EditText)findViewById(R.id.EditTextPatologia);

		allergie = (Spinner) findViewById(R.id.SpinnerAllergie);
		allergie_altro = (EditText)findViewById(R.id.EditTextAllergieAltro);
		allergie.setOnItemSelectedListener(new OnItemSelectedListener() {

			public void onItemSelected(AdapterView<?> parent, View v, int position, long id) {
				if(!((String)parent.getItemAtPosition(position)).equals(getString(R.string.altro)))
					allergie_altro.setVisibility(View.GONE);
				else
				{
					allergie_altro.setVisibility(View.VISIBLE);
					allergie_altro.setText("");
				}
			}
			public void onNothingSelected(AdapterView<?> arg0) {
				// TODO Auto-generated method stub

			}});



		codice_barre = (EditText)findViewById(R.id.EditTextCodiceBarre);
		anni = (EditText)findViewById(R.id.EditTextAnni);
		alt= (EditText)findViewById(R.id.EditTextALT);
		ast= (EditText)findViewById(R.id.EditTextAST);
		creatinina= (EditText)findViewById(R.id.EditTextCreatinina);

	}


	/**
	 * Set up the {@link android.app.ActionBar}.
	 */
	private void setupActionBar() {

		getActionBar().setDisplayHomeAsUpEnabled(true);

	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.nuovo_paziente, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case android.R.id.home:
			// This ID represents the Home or Up button. In the case of this
			// activity, the Up button is shown. Use NavUtils to allow users
			// to navigate up one level in the application structure. For
			// more details, see the Navigation pattern on Android Design:
			//
			// http://developer.android.com/design/patterns/navigation.html#up-vs-back
			//
			NavUtils.navigateUpFromSameTask(this);
			return true;
		}
		return super.onOptionsItemSelected(item);
	}

	@Override
	protected void onStop() {
		// TODO Auto-generated method stub
		super.onStop();
	}

	public void showDatePicker(View v)
	{
		lastClicked = v.getId();
		DatePickerFragment date = new DatePickerFragment();

		// Set Up Current Date Into dialog

		Bundle args = new Bundle(); 


		//variabili di appoggio
		String testo_settato;
		StringTokenizer tokenizer;

		//se mai settati mostro data odierna, altrimenti la data precedentemente impostata
		switch(lastClicked) {

		case R.id.ButtonDataDiIngresso:
		{
			testo_settato = data_di_ingresso.getText().toString();

			tokenizer = new StringTokenizer(testo_settato, "/");
			args.putInt("day", Integer.parseInt(tokenizer.nextToken()));				
			args.putInt("month", Integer.parseInt(tokenizer.nextToken()) - 1);
			args.putInt("year", Integer.parseInt(tokenizer.nextToken()));

			break;
		}
		}

		date.setArguments(args);

		// Set Call back to capture selected date

		date.setCallBack(ondate);
		date.show(getSupportFragmentManager(), "Date Picker");
	}

	OnDateSetListener ondate = new OnDateSetListener() {
		@Override
		public void onDateSet(DatePicker view, int year, int monthOfYear, int dayOfMonth) 
		{

			switch(lastClicked) {

			case R.id.ButtonDataDiIngresso:

				data_di_ingresso.setText(
						new StringBuilder()
						.append(dayOfMonth).append("/")
						.append(monthOfYear + 1).append("/")
						.append(year));
				break;
			}

		}
	};

	public void procedi(View v)
	{
		//Disabilito bottone per prevenire click multipli
		v.setClickable(false);
		//recupero campi

		if(fieldsAreNotFilled())
		{
			Toast.makeText(this, getString(R.string.campinoncompleti), Toast.LENGTH_SHORT).show();
			v.setClickable(true);
		}
		else if(codiceGiaUtilizzato())
		{
			Toast.makeText(this, getString(R.string.codicegiautilizzato), Toast.LENGTH_SHORT).show();
			v.setClickable(true);
		}
		else
		{
			fillPaziente();  //metodo privato

			//invio intent con paziente
			Intent intent = new Intent(this, TabProtocollo.class);
			intent.putExtra(getString(R.string.IntentPaziente), paziente);
			//riabilito bottone
			v.setClickable(true);
			startActivity(intent);
		}


	}

	public void getCodeBarFromCamera(View v)
	{

		if(v.getId() == R.id.ButtonCodiceBarre) {
			// start scanning
			IntentIntegrator intentIntegrator = new IntentIntegrator(this);
			intentIntegrator.initiateScan();
		}
	}

	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		IntentResult scanResult = IntentIntegrator.parseActivityResult(requestCode, resultCode, data);
		if(scanResult != null) {
			Log.i("SCAN", "scan result: " + scanResult);
			((EditText)findViewById(R.id.EditTextCodiceBarre)).setText(scanResult.getContents());
		} else
			Log.e("SCAN", "Sorry, the scan was unsuccessful...");
	}



	private void fillPaziente()
	{
		//Settare Stringhe vuote nel caso di campi vuoti
		paziente.setNome( nome.getText().toString().trim());
		paziente.setCognome( cognome.getText().toString().trim());
		paziente.setData_di_ingresso(data_di_ingresso.getText().toString());
		paziente.setNumero_letto(numero_letto.getText().toString().trim());
		paziente.setReparto( reparto.getSelectedItem().toString());
		paziente.setPiano( piano.getSelectedItem().toString());
		paziente.setCodice_diagnosi( codice_diagnosi.getText().toString().trim());
		paziente.setCodice_intervento(codice_intervento.getText().toString().trim() );

		paziente.setPatologia(patologia.getText().toString().trim());

		paziente.setAllergie( allergie.getSelectedItem().toString());
		if (paziente.getAllergie().equals(R.string.altro))
			paziente.setAllergie_altro( allergie_altro.getText().toString().trim());
		else
			paziente.setAllergie_altro("");
		paziente.setCodice_a_barre( codice_barre.getText().toString().trim());
		paziente.setAnni(anni.getText().toString().trim());

		paziente.setAlt(alt.getText().toString().trim());
		paziente.setAst(ast.getText().toString().trim());
		paziente.setCreatinina(creatinina.getText().toString().trim());
	}

	private boolean fieldsAreNotFilled()
	{
		boolean notfilled = nome.getText().toString().trim().isEmpty() 
				|| cognome.getText().toString().trim().isEmpty()
				|| numero_letto.getText().toString().trim().isEmpty()
				|| codice_diagnosi.getText().toString().trim().isEmpty()
				|| codice_intervento.getText().toString().trim().isEmpty()
				|| patologia.getText().toString().trim().isEmpty()
				|| codice_barre.getText().toString().trim().isEmpty();
		boolean inconsistency = allergie.getSelectedItem().toString().equals(getString(R.string.altro)) 
				&&  allergie_altro.getText().toString().isEmpty();
		PazientiDBAdapter datasource = new PazientiDBAdapter(this);
		datasource.open();
		
		return notfilled || inconsistency;
	}
	
	private boolean codiceGiaUtilizzato()
	{
		PazientiDBAdapter datasource = new PazientiDBAdapter(this);
		datasource.open();
		boolean result = datasource.codeAlreadyUsed(codice_barre.getText().toString().trim());
		datasource.close();
		return result;
	}
}
