package prova.med.activities;

import prova.med.Ilisterners.IOnPazienteSelectedListener;
import prova.med.boris.R;
import prova.med.frag.PianoFrag;
import android.os.Bundle;
import android.app.ActionBar;
import android.app.Activity;
import android.app.Fragment;
import android.app.FragmentTransaction;
import android.app.ActionBar.Tab;
import android.content.Intent;
import android.view.Menu;
import android.view.MenuItem;
import android.support.v4.app.NavUtils;

public class VisualizzaPazienti extends Activity implements IOnPazienteSelectedListener{

	

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_visualizza_pazienti);

		//inizializzazione e aggiunta tab dei protocolli
		//label del tab -> tag del fragment associato
				ActionBar actionBar = getActionBar(); 
				actionBar.setNavigationMode(ActionBar.NAVIGATION_MODE_TABS); 
				
				String[] piani = getResources().getStringArray(R.array.piano_array);
				
				for(String piano : piani)
				{
					String label = piano; 
					Tab tab = actionBar.newTab(); 
					tab.setText(label);
					TabListener<PianoFrag> t = new TabListener<PianoFrag>(this, label, PianoFrag.class); 
					tab.setTabListener(t); 
					actionBar.addTab(tab); 
					
				}


	}


	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.visualizza_pazienti, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case android.R.id.home:
			// This ID represents the Home or Up button. In the case of this
			// activity, the Up button is shown. Use NavUtils to allow users
			// to navigate up one level in the application structure. For
			// more details, see the Navigation pattern on Android Design:
			//
			// http://developer.android.com/design/patterns/navigation.html#up-vs-back
			//
			NavUtils.navigateUpFromSameTask(this);
			return true;
		}
		return super.onOptionsItemSelected(item);
	}
	
	private class TabListener<T extends Fragment> implements ActionBar.TabListener { 
		private Fragment mFragment; 
		private final Activity mActivity; 
		private final String mTag; 
		private final Class<T> mClass; 
		public TabListener(Activity activity, String tag, Class<T> clz) { 
			mActivity = activity; 
			mTag = tag; 
			mClass = clz; 
		} 
		public void onTabSelected(Tab tab, FragmentTransaction ft) { 
			if (mFragment == null) { 
				mFragment = Fragment.instantiate(mActivity, mClass.getName()); 
				ft.add(android.R.id.content, mFragment, mTag); 
			} else { 
				ft.attach(mFragment); 
			} 
		} 
		public void onTabUnselected(Tab tab, FragmentTransaction ft) { 
			if (mFragment != null) { 
				ft.detach(mFragment); 
			} 
		} 
		public void onTabReselected(Tab tab, FragmentTransaction ft) {  
			// User selected the already selected tab. Usually do nothing. 
		} 
	}

	@Override
	public void onPazienteSelected(String codice_a_barre) {
		
		Intent intent = new Intent( this , VisualizzaRilevazioni.class);
		intent.putExtra(getString(R.string.IntentCodBarre), codice_a_barre );
		startActivity(intent);
	}


}
