package prova.med.activities;

import prova.med.boris.R;
import prova.med.db.ProtocolloADBAdapter;
import prova.med.db.ProtocolloBDBAdapter;
import prova.med.db.ProtocolloCDBAdapter;
import prova.med.db.ProtocolloDDBAdapter;
import prova.med.obj.AbstractProtocollo;
import prova.med.obj.ProtocolloA;
import prova.med.obj.ProtocolloB;
import prova.med.obj.ProtocolloC;
import prova.med.obj.ProtocolloD;
import android.os.Bundle;
import android.app.Activity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.TextView;
import android.support.v4.app.NavUtils;
import android.annotation.TargetApi;
import android.content.Intent;
import android.os.Build;

public class VisualizzaProtocollo extends Activity {

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		Intent intent = getIntent();
		String codice_a_barre = intent.getStringExtra(getString(R.string.IntentCodBarre));
		String nome_protocollo = intent.getStringExtra(getString(R.string.IntentNomeProtocollo));

		//setLayoutProtocollo(nome_protocollo);
		AbstractProtocollo protocollo = findProtocol(nome_protocollo, codice_a_barre);
		if(protocollo != null)
		{
			setProtocolLayout(protocollo);
		}
		//setContentView(R.layout.activity_visualizza_protocollo);
		// Show the Up button in the action bar.
		setupActionBar();
	}

	/**
	 * Set up the {@link android.app.ActionBar}, if the API is available.
	 */
	@TargetApi(Build.VERSION_CODES.HONEYCOMB)
	private void setupActionBar() {
		if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.HONEYCOMB) {
			getActionBar().setDisplayHomeAsUpEnabled(true);
		}
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.visualizza_protocollo, menu);
		return true;
	}


	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case android.R.id.home:
			// This ID represents the Home or Up button. In the case of this
			// activity, the Up button is shown. Use NavUtils to allow users
			// to navigate up one level in the application structure. For
			// more details, see the Navigation pattern on Android Design:
			//
			// http://developer.android.com/design/patterns/navigation.html#up-vs-back
			//
			NavUtils.navigateUpFromSameTask(this);
			return true;
		}
		return super.onOptionsItemSelected(item);
	}

	private AbstractProtocollo findProtocol(String nome_protocollo, String codice_a_barre)
	{
		AbstractProtocollo protocollo = null;
		if(nome_protocollo.equals(ProtocolloA.class.getSimpleName()))
		{
			ProtocolloADBAdapter datasource = new ProtocolloADBAdapter(this);
			datasource.open();
			protocollo = datasource.getProtocollo(codice_a_barre);
			datasource.close();
		}
		else if(nome_protocollo.equals(ProtocolloB.class.getSimpleName()))
		{
			ProtocolloBDBAdapter datasource = new ProtocolloBDBAdapter(this);
			datasource.open();
			protocollo = datasource.getProtocollo(codice_a_barre);
			datasource.close();
		}
		else if(nome_protocollo.equals(ProtocolloC.class.getSimpleName()))
		{
			ProtocolloCDBAdapter datasource = new ProtocolloCDBAdapter(this);
			datasource.open();
			protocollo = datasource.getProtocollo(codice_a_barre);
			datasource.close();
		}
		else if(nome_protocollo.equals(ProtocolloD.class.getSimpleName()))
		{
			ProtocolloDDBAdapter datasource = new ProtocolloDDBAdapter(this);
			datasource.open();
			protocollo = datasource.getProtocollo(codice_a_barre);
			datasource.close();
		}
		return protocollo;
	}

	private void setProtocolLayout(AbstractProtocollo protocollo)
	{
		if(protocollo.getClass().getSimpleName().equals(ProtocolloA.class.getSimpleName()))
		{
			setContentView(R.layout.layout_a);
			setProtocolloA((ProtocolloA) protocollo);
		}
		else if(protocollo.getClass().getSimpleName().equals(ProtocolloB.class.getSimpleName()))
		{
			setContentView(R.layout.layout_b);
			setProtocolloB((ProtocolloB) protocollo);
		}
		else if(protocollo.getClass().getSimpleName().equals(ProtocolloC.class.getSimpleName()))
		{
			setContentView(R.layout.layout_c);
			setProtocolloC((ProtocolloC) protocollo);
		}
		else if(protocollo.getClass().getSimpleName().equals(ProtocolloD.class.getSimpleName()))
		{
			setContentView(R.layout.layout_d);
			setProtocolloD((ProtocolloD) protocollo);
		}
	}

	private void setProtocolloA(ProtocolloA p)
	{
		if(p.getFarmacopos1().getNome().equals("-"))
		{
			findViewById(R.id.textViewFarmaco1label).setVisibility(View.GONE);
			findViewById(R.id.textViewFarmaco1value).setVisibility(View.GONE);
		}
		else
		{
			((TextView)findViewById(R.id.textViewFarmaco1label)).setText(p.getFarmacopos1().getNome());
			((TextView)findViewById(R.id.textViewFarmaco1value)).setText(p.getFarmacopos1().getPosologia());
		}

		if(p.getFarmacopos2().getNome().trim().isEmpty())
		{
			findViewById(R.id.textViewFarmaco2label).setVisibility(View.GONE);
			findViewById(R.id.textViewFarmaco2value).setVisibility(View.GONE); 
		}
		else
		{
			((TextView)findViewById(R.id.textViewFarmaco2label)).setText(p.getFarmacopos2().getNome());
			((TextView)findViewById(R.id.textViewFarmaco2value)).setText(p.getFarmacopos2().getPosologia());
		}

		((TextView)findViewById(R.id.textViewRescuelabel)).setText(p.getRescue().getNome());
		((TextView)findViewById(R.id.textViewRescuevalue)).setText(p.getRescue().getPosologia());	

		if(p.getGastro().getNome().equals("-"))
			findViewById(R.id.LayoutGastroprotezione).setVisibility(View.GONE);
		else
		{
			((TextView)findViewById(R.id.textViewGastrovalue)).setText(p.getGastro().getNome());
			((TextView)findViewById(R.id.textViewGastroDose)).setText(p.getGastro().getDosaggio());
		}

		if(p.getGastro().getNome().equals("-"))
		{
			findViewById(R.id.textViewGastroprotezione).setVisibility(View.GONE);
			findViewById(R.id.LayoutGastroprotezione).setVisibility(View.GONE);
		}
		else
		{
			((TextView)findViewById(R.id.textViewGastrovalue)).setText(p.getGastro().getNome());
			((TextView)findViewById(R.id.textViewGastroDose)).setText(p.getGastro().getDosaggio());
		}

		if(p.getPonv().getNome().equals("-"))
		{
			findViewById(R.id.textViewPonv).setVisibility(View.GONE);
			findViewById(R.id.LayoutPonv).setVisibility(View.GONE);
		}
		else
		{
			((TextView)findViewById(R.id.textViewPonvlabel)).setText(p.getPonv().getNome());
			((TextView)findViewById(R.id.textViewPonvPos)).setText(p.getPonv().getPosologia());
			((TextView)findViewById(R.id.textViewPonvDose)).setText(p.getPonv().getDosaggio());
		}
	}

	private void setProtocolloB(ProtocolloB p)
	{
		((TextView)findViewById(R.id.textViewFarmaco1label)).setText(p.getFarmaco1().getNome());
		((TextView)findViewById(R.id.textViewFarmaco1value)).setText(p.getFarmaco1().getDosaggio());
		((TextView)findViewById(R.id.textViewFarmaco2label)).setText(p.getFarmaco2().getNome());
		((TextView)findViewById(R.id.textViewFarmaco2value)).setText(p.getFarmaco2().getDosaggio());

		if(p.getAltro_farmaco().getNome().trim().isEmpty())
		{
			findViewById(R.id.textViewFarmaco3label).setVisibility(View.GONE);
			findViewById(R.id.textViewFarmaco3value).setVisibility(View.GONE);
		}
		else
		{
			((TextView)findViewById(R.id.textViewFarmaco3label)).setText(p.getAltro_farmaco().getNome());
			((TextView)findViewById(R.id.textViewFarmaco3value)).setText(p.getAltro_farmaco().getDosaggio());
		}

		((TextView)findViewById(R.id.textViewRescuelabel)).setText(p.getRescue().getNome());
		((TextView)findViewById(R.id.textViewRescuevalue)).setText(p.getRescue().getPosologia());	

		((TextView)findViewById(R.id.textViewVolumevalue)).setText(p.getElastomero().getVolume());
		((TextView)findViewById(R.id.textViewVelocitavalue)).setText(p.getElastomero().getVelocita());	

		if(!p.getIntegra_paracetamolo())
			findViewById(R.id.TextViewIntegraParacetamolo).setVisibility(View.GONE);
		if(p.getGastro().getNome().equals("-"))
			findViewById(R.id.LayoutGastroprotezione).setVisibility(View.GONE);
		else
		{
			((TextView)findViewById(R.id.textViewGastrovalue)).setText(p.getGastro().getNome());
			((TextView)findViewById(R.id.textViewGastroDose)).setText(p.getGastro().getDosaggio());
		}

		if(p.getGastro().getNome().equals("-"))
		{
			findViewById(R.id.textViewGastroprotezione).setVisibility(View.GONE);
			findViewById(R.id.LayoutGastroprotezione).setVisibility(View.GONE);
		}
		else
		{
			((TextView)findViewById(R.id.textViewGastrovalue)).setText(p.getGastro().getNome());
			((TextView)findViewById(R.id.textViewGastroDose)).setText(p.getGastro().getDosaggio());
		}

		if(p.getPonv().getNome().equals("-"))
		{
			findViewById(R.id.textViewPonv).setVisibility(View.GONE);
			findViewById(R.id.LayoutPonv).setVisibility(View.GONE);
		}
		else
		{
			((TextView)findViewById(R.id.textViewPonvlabel)).setText(p.getPonv().getNome());
			((TextView)findViewById(R.id.textViewPonvPos)).setText(p.getPonv().getPosologia());
			((TextView)findViewById(R.id.textViewPonvDose)).setText(p.getPonv().getDosaggio());
		}
	}
	private void setProtocolloC(ProtocolloC p)
	{
		((TextView)findViewById(R.id.textViewFarmaco1label)).setText(p.getFarmaco().getNome());
		((TextView)findViewById(R.id.textViewFarmaco1value)).setText(p.getFarmaco().getDosaggio());

		if(p.getAltro_farmaco().getNome().trim().isEmpty())
		{
			findViewById(R.id.textViewFarmaco2label).setVisibility(View.GONE);
			findViewById(R.id.textViewFarmaco2value).setVisibility(View.GONE);
			}
		else
		{
			((TextView)findViewById(R.id.textViewFarmaco2label)).setText(p.getAltro_farmaco().getNome());
			((TextView)findViewById(R.id.textViewFarmaco2value)).setText(p.getAltro_farmaco().getDosaggio());
		}

		((TextView)findViewById(R.id.textViewRescuelabel)).setText(p.getRescue().getNome());
		((TextView)findViewById(R.id.textViewRescuevalue)).setText(p.getRescue().getPosologia());	

		((TextView)findViewById(R.id.textViewInfusionecontinuavalue)).setText(p.getInfusione_continua());
		((TextView)findViewById(R.id.textViewDoseBolovalue)).setText(p.getDose_bolo());
		((TextView)findViewById(R.id.textViewTempoBloccovalue)).setText(p.getTempo_blocco());
		((TextView)findViewById(R.id.textViewLimite4orevalue)).setText(p.getLimite_ore());
		((TextView)findViewById(R.id.textViewDoseTotalevalue)).setText(p.getDose_totale());

		if(!p.getIntegra_paracetamolo())
			findViewById(R.id.TextViewIntegraParacetamolo).setVisibility(View.GONE);
		if(p.getGastro().getNome().equals("-"))
		{
			findViewById(R.id.textViewGastroprotezione).setVisibility(View.GONE);
			findViewById(R.id.LayoutGastroprotezione).setVisibility(View.GONE);
		}
		else
		{
			((TextView)findViewById(R.id.textViewGastrovalue)).setText(p.getGastro().getNome());
			((TextView)findViewById(R.id.textViewGastroDose)).setText(p.getGastro().getDosaggio());
		}

		if(p.getGastro().getNome().equals("-"))
			findViewById(R.id.LayoutGastroprotezione).setVisibility(View.GONE);
		else
		{
			((TextView)findViewById(R.id.textViewGastrovalue)).setText(p.getGastro().getNome());
			((TextView)findViewById(R.id.textViewGastroDose)).setText(p.getGastro().getDosaggio());
		}

		if(p.getPonv().getNome().equals("-"))
		{
			findViewById(R.id.textViewPonv).setVisibility(View.GONE);
			findViewById(R.id.LayoutPonv).setVisibility(View.GONE);
		}
		else
		{
			((TextView)findViewById(R.id.textViewPonvlabel)).setText(p.getPonv().getNome());
			((TextView)findViewById(R.id.textViewPonvPos)).setText(p.getPonv().getPosologia());
			((TextView)findViewById(R.id.textViewPonvDose)).setText(p.getPonv().getDosaggio());
		}
	}
	private void setProtocolloD(ProtocolloD p)
	{
		((TextView)findViewById(R.id.textViewFarmaco1label)).setText(p.getFarmaco_non_oppiaceo().getNome());
		((TextView)findViewById(R.id.textViewFarmaco1value)).setText(p.getFarmaco_non_oppiaceo().getDosaggio());

		if(p.getFarmaco_oppiaceo().getNome().equals("-"))
			findViewById(R.id.textViewFarmaco2label).setVisibility(View.GONE);
		else
		{
			((TextView)findViewById(R.id.textViewFarmaco2label)).setText(p.getFarmaco_oppiaceo().getNome());
			((TextView)findViewById(R.id.textViewFarmaco2value)).setText(p.getFarmaco_oppiaceo().getDosaggio());
		}

		((TextView)findViewById(R.id.textViewRescuelabel)).setText(p.getRescue().getNome());
		((TextView)findViewById(R.id.textViewRescuevalue)).setText(p.getRescue().getPosologia());	

		((TextView)findViewById(R.id.textViewVolumevalue)).setText(p.getElastomero().getVolume());
		((TextView)findViewById(R.id.textViewVelocitavalue)).setText(p.getElastomero().getVelocita());	

		if(!p.getIntegra_paracetamolo())
			findViewById(R.id.TextViewIntegraParacetamolo).setVisibility(View.GONE);
		if(p.getGastro().getNome().equals("-"))
			findViewById(R.id.LayoutGastroprotezione).setVisibility(View.GONE);
		else
		{
			((TextView)findViewById(R.id.textViewGastrovalue)).setText(p.getGastro().getNome());
			((TextView)findViewById(R.id.textViewGastroDose)).setText(p.getGastro().getDosaggio());
		}

		if(p.getGastro().getNome().equals("-"))
		{
			findViewById(R.id.textViewGastroprotezione).setVisibility(View.GONE);
			findViewById(R.id.LayoutGastroprotezione).setVisibility(View.GONE);
		}
		else
		{
			((TextView)findViewById(R.id.textViewGastrovalue)).setText(p.getGastro().getNome());
			((TextView)findViewById(R.id.textViewGastroDose)).setText(p.getGastro().getDosaggio());
		}

		if(p.getPonv().getNome().equals("-"))
		{
			findViewById(R.id.textViewPonv).setVisibility(View.GONE);
			findViewById(R.id.LayoutPonv).setVisibility(View.GONE);
		}
		else
		{
			((TextView)findViewById(R.id.textViewPonvlabel)).setText(p.getPonv().getNome());
			((TextView)findViewById(R.id.textViewPonvPos)).setText(p.getPonv().getPosologia());
			((TextView)findViewById(R.id.textViewPonvDose)).setText(p.getPonv().getDosaggio());
		}
	}
}