package prova.med.activities;

import java.util.Collections;
import java.util.List;

import prova.med.boris.R;
import prova.med.db.RilevazioneDBAdapter;
import prova.med.listviewadapters.ArrayRilevazioneAdapter;
import prova.med.obj.Rilevazione;
import android.os.AsyncTask;
import android.os.Bundle;
import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.ListView;
import android.support.v4.app.NavUtils;

public class VisualizzaRilevazioni extends Activity {

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_rilevazioni);
		Intent intent = getIntent();
		String codice_a_barre = intent.getExtras().getString( getString(R.string.IntentCodBarre));
		setTitle(codice_a_barre);
		// Show the Up button in the action bar.
		setupActionBar();

		new AsyncTaskRilevazioni(this).execute(codice_a_barre);
	}

	/**
	 * Set up the {@link android.app.ActionBar}.
	 */
	private void setupActionBar() {

		getActionBar().setDisplayHomeAsUpEnabled(true);

	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.rilevazioni, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case android.R.id.home:
			// This ID represents the Home or Up button. In the case of this
			// activity, the Up button is shown. Use NavUtils to allow users
			// to navigate up one level in the application structure. For
			// more details, see the Navigation pattern on Android Design:
			//
			// http://developer.android.com/design/patterns/navigation.html#up-vs-back
			//
			NavUtils.navigateUpFromSameTask(this);
			return true;
		}
		return super.onOptionsItemSelected(item);
	}

	private class AsyncTaskRilevazioni extends AsyncTask < String , Void , List<Rilevazione> > {

		private ProgressDialog      progressDialog ;
		private Activity            targetActivity ;
		private String codice_a_barre = null;
		public AsyncTaskRilevazioni ( Activity activity ) {
			this.targetActivity = activity ;
			// this.needToShow = true;
			progressDialog = new ProgressDialog ( targetActivity ) ;
			progressDialog.setCancelable ( false ) ;
			progressDialog.setMessage ( getString(R.string.attendere) ) ;
			progressDialog.setTitle ( getString(R.string.recuperodati)) ;
			progressDialog.setIndeterminate ( true ) ;
		}

		@ Override
		protected void onPreExecute ( ) {
			progressDialog.show ( ); 
		}

		@ Override
		protected List<Rilevazione> doInBackground ( String ... params) {
			// Creo Fragment delle rilevazioni
			this.codice_a_barre = params[0];
			RilevazioneDBAdapter datasource = new RilevazioneDBAdapter(getApplicationContext());
			datasource.open();
			List<Rilevazione> rilevazionilist = datasource.getRilevazioni(this.codice_a_barre);
			datasource.close();
			return rilevazionilist ;
		}

		@ Override
		protected void onPostExecute ( List<Rilevazione> result) {
			if(progressDialog != null && progressDialog.isShowing()){
				progressDialog.dismiss ( ) ;

				if(result.isEmpty())
					findViewById(R.id.textViewNessunaRilevazione).setVisibility(View.VISIBLE);
				else
				{
					Collections.sort(result);
					Collections.reverse(result);
					ListView listview = (ListView) findViewById(R.id.ListViewVisualizzaRilevazioni);
					ArrayRilevazioneAdapter arrayrilevazioneadapter = new ArrayRilevazioneAdapter(targetActivity, R.layout.rowrilevazione, result);
					listview.setAdapter(arrayrilevazioneadapter);
					listview.setVisibility(View.VISIBLE);
				}
			}
		}
	}
}
