package prova.med.db;


import android.content.Context;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

public class DBAdapter {

	public static final String DATABASE_NAME = "db_stuff"; //$NON-NLS-1$

	public static final int DATABASE_VERSION = 1;

	private final Context context; 
	private DatabaseHelper DBHelper;
	private SQLiteDatabase db;

	private static final String CREATE_TABLE_PAZIENTI =
			"create table if not exists " + PazientiDBAdapter.DATABASE_TABLE_PAZIENTI + " (_id integer primary key autoincrement, " //$NON-NLS-1$
			+ PazientiDBAdapter.NOME+ " TEXT NOT NULL," //$NON-NLS-1$
			+ PazientiDBAdapter.COGNOME+ " TEXT NOT NULL," //$NON-NLS-1$
			+ PazientiDBAdapter.INGRESSO+ " TEXT NOT NULL," 
			+ PazientiDBAdapter.NLETTO+ " TEXT NOT NULL," 
			+ PazientiDBAdapter.REPARTO+ " TEXT NOT NULL," 
			+ PazientiDBAdapter.PIANO+ " TEXT NOT NULL," 
			+ PazientiDBAdapter.CODINTERVENTO+ " TEXT NOT NULL," 
			+ PazientiDBAdapter.CODDIAGNOSI+ " TEXT NOT NULL," 
			+ PazientiDBAdapter.PATOLOGIA+ " TEXT," 
			+ PazientiDBAdapter.ALLERGIE+ " TEXT," 
			+ PazientiDBAdapter.ALLERGIEALTRO+ " TEXT," 
			+ PazientiDBAdapter.CODBARRE+ " TEXT UNIQUE NOT NULL," 
			+ PazientiDBAdapter.CREATININA+ " TEXT," 
			+ PazientiDBAdapter.ALT+ " TEXT," 
			+ PazientiDBAdapter.AST+ " TEXT," 
			+ PazientiDBAdapter.ANNI+ " TEXT," 
			+ PazientiDBAdapter.PROTOCOLLO + " TEXT,"
			+ PazientiDBAdapter.ULTIMA_MODIFICA + " DATETIME DEFAULT (DATETIME(current_timestamp, 'localtime')))";

	private static final String CREATE_TABLE_PROTOCOLLOA =
			"create table if not exists " + ProtocolloADBAdapter.DATABASE_TABLE_PROTOCOLLOA + " (_id integer primary key autoincrement, "
					+ ProtocolloADBAdapter.CODBARRE + " TEXT UNIQUE,"
					+ ProtocolloADBAdapter.FARMACO1_NOME + " TEXT,"
					+ ProtocolloADBAdapter.FARMACO1_POS + " TEXT,"
					+ ProtocolloADBAdapter.FARMACO2_NOME + " TEXT,"
					+ ProtocolloADBAdapter.FARMACO2_POS + " TEXT,"
					+ ProtocolloADBAdapter.RESCUE_NOME + " TEXT,"
					+ ProtocolloADBAdapter.RESCUE_POS + " TEXT,"
					+ ProtocolloADBAdapter.GASTRO_NOME + " TEXT,"
					+ ProtocolloADBAdapter.GASTRO_DOSE + " TEXT,"
					+ ProtocolloADBAdapter.PONV_NOME + " TEXT,"
					+ ProtocolloADBAdapter.PONV_POS + " TEXT,"
					+ ProtocolloADBAdapter.PONV_DOSE + " TEXT"
					+ ");";

	private static final String CREATE_TABLE_PROTOCOLLOB =
			"create table if not exists "+  ProtocolloBDBAdapter.DATABASE_TABLE_PROTOCOLLOB +" (_id integer primary key autoincrement, "
					+ ProtocolloBDBAdapter.CODBARRE + " TEXT UNIQUE,"
					+ ProtocolloBDBAdapter.FARMACO1_NOME  + " TEXT,"
					+ ProtocolloBDBAdapter.FARMACO1_DOSE + " TEXT,"
					+ ProtocolloBDBAdapter.FARMACO2_NOME  + " TEXT,"
					+ ProtocolloBDBAdapter.FARMACO2_DOSE  + " TEXT,"
					+ ProtocolloBDBAdapter.ALTROFARMACO_NOME + " TEXT,"
					+ ProtocolloBDBAdapter.ALTROFARMACO_DOSE  + " TEXT,"
					+ ProtocolloBDBAdapter.RESCUE_NOME + " TEXT,"
					+ ProtocolloBDBAdapter.RESCUE_POS + " TEXT,"
					+ ProtocolloBDBAdapter.ELASTOMERO_VOL + " TEXT,"
					+ ProtocolloBDBAdapter.ELASTOMERO_VEL  + " INTEGER,"
					+ ProtocolloBDBAdapter.INTEGRA + " TEXT,"
					+ ProtocolloBDBAdapter.GASTRO_NOME  + " TEXT,"
					+ ProtocolloBDBAdapter.GASTRO_DOSE + " TEXT,"
					+ ProtocolloBDBAdapter.PONV_NOME+ " TEXT,"
					+ ProtocolloBDBAdapter.PONV_POS+ " TEXT,"
					+ ProtocolloBDBAdapter.PONV_DOSE  + " TEXT"
					+ ");";

	private static final String CREATE_TABLE_PROTOCOLLOC =
			"create table if not exists " + ProtocolloCDBAdapter.DATABASE_TABLE_PROTOCOLLOC +  " (_id integer primary key autoincrement, "
					+ ProtocolloCDBAdapter.CODBARRE + " TEXT UNIQUE,"
					+ ProtocolloCDBAdapter.FARMACO1_NOME + " TEXT,"
					+ ProtocolloCDBAdapter.FARMACO1_DOSE + " TEXT,"
					+ ProtocolloCDBAdapter.FARMACO2_NOME + " TEXT,"
					+ ProtocolloCDBAdapter.FARMACO2_DOSE + " TEXT,"
					+ ProtocolloCDBAdapter.SOL_FISIOLOGICA + " TEXT,"
					+ ProtocolloCDBAdapter.VOLUME_TOTALE + " TEXT,"
					+ ProtocolloCDBAdapter.RESCUE_NOME + " TEXT,"
					+ ProtocolloCDBAdapter.RESCUE_POS + " TEXT,"
					+ ProtocolloCDBAdapter.INFUSIONE_CONTINUA + " TEXT,"
					+ ProtocolloCDBAdapter.DOSE_BOLO + " TEXT,"
					+ ProtocolloCDBAdapter.TEMPO_BLOCCO + " TEXT,"
					+ ProtocolloCDBAdapter.TEMPO_LIMITE + " TEXT,"
					+ ProtocolloCDBAdapter.DOSE_TOTALE + " TEXT,"
					+ ProtocolloCDBAdapter.INTEGRA + " INTEGER,"
					+ ProtocolloCDBAdapter.GASTRO_NOME + " TEXT,"
					+ ProtocolloCDBAdapter.GASTRO_DOSE + " TEXT,"
					+ ProtocolloCDBAdapter.PONV_NOME + " TEXT,"
					+ ProtocolloCDBAdapter.PONV_POS + " TEXT,"
					+ ProtocolloCDBAdapter.PONV_DOSE + " TEXT"
					+ ");";

	private static final String CREATE_TABLE_PROTOCOLLOD =
			"create table if not exists " + ProtocolloDDBAdapter.DATABASE_TABLE_PROTOCOLLOD + " (_id integer primary key autoincrement, "
					+ ProtocolloDDBAdapter.CODBARRE + " TEXT UNIQUE,"
					+ ProtocolloDDBAdapter.FARMACO1_NOME + " TEXT,"
					+ ProtocolloDDBAdapter.FARMACO1_DOSE + " TEXT,"
					+ ProtocolloDDBAdapter.FARMACO2_NOME + " TEXT,"
					+ ProtocolloDDBAdapter.FARMACO2_DOSE + " TEXT,"
					+ ProtocolloDDBAdapter.RESCUE_NOME + " TEXT,"
					+ ProtocolloDDBAdapter.RESCUE_POS+ " TEXT,"
					+ ProtocolloDDBAdapter.ELASTOMERO_VOL + " TEXT,"
					+ ProtocolloDDBAdapter.ELASTOMERO_VEL + " TEXT,"
					+ ProtocolloDDBAdapter.INTEGRA + " TEXT,"
					+ ProtocolloDDBAdapter.GASTRO_NOME + " TEXT,"
					+ ProtocolloDDBAdapter.GASTRO_DOSE + " TEXT,"
					+ ProtocolloDDBAdapter.PONV_NOME + " TEXT,"
					+ ProtocolloDDBAdapter.PONV_POS + " TEXT,"
					+ ProtocolloDDBAdapter.PONV_DOSE + " TEXT"
					+ ");";

	private static final String CREATE_TABLE_RILEVAZIONI =
			"create table if not exists "+ RilevazioneDBAdapter.DATABASE_TABLE_RILEVAZIONI +" (_id integer primary key autoincrement, "
					+ RilevazioneDBAdapter.CODBARRE + " TEXT NOT NULL,"
					+ RilevazioneDBAdapter.DATA + " TEXT NOT NULL,"
					+ RilevazioneDBAdapter.ORA + " TEXT NOT NULL,"
					+ RilevazioneDBAdapter.SVS_RIP + " INTEGER NOT NULL,"
					+ RilevazioneDBAdapter.SVS_SFO + " INTEGER NOT NULL,"
					+ RilevazioneDBAdapter.VAS_RIP + " INTEGER NOT NULL,"
					+ RilevazioneDBAdapter.VAS_SFO + " INTEGER NOT NULL,"
					+ RilevazioneDBAdapter.SEDE + " INTEGER NOT NULL,"
					+ RilevazioneDBAdapter.SEDAZIONE + " INTEGER NOT NULL,"
					+ RilevazioneDBAdapter.FR + " INTEGER NOT NULL,"
					+ RilevazioneDBAdapter.SO2 + " INTEGER NOT NULL,"
					+ RilevazioneDBAdapter.PA + " INTEGER NOT NULL,"
					+ RilevazioneDBAdapter.FC + " INTEGER NOT NULL,"
					+ RilevazioneDBAdapter.EFFETTI_AVVERSI  + " TEXT,"
					+ RilevazioneDBAdapter.NOTE  + " TEXT,"
					+" UNIQUE ( " + RilevazioneDBAdapter.CODBARRE  + " , " + RilevazioneDBAdapter.DATA + " , " +  RilevazioneDBAdapter.ORA + " )"
					+ ");";
	
	private static final String CREATE_TABLE_PAZIENTI_CANCELLATI =
			"create table if not exists "+ PazientiDBAdapter.DATABASE_TABLE_PAZIENTI_CANCELLATI +" (_id integer primary key autoincrement, "
					+ PazientiDBAdapter.CODBARRE + " TEXT UNIQUE NOT NULL,"
					+ PazientiDBAdapter.ULTIMA_MODIFICA + " DATETIME DEFAULT (DATETIME(current_timestamp, 'localtime')))";
	/**
	 * Constructor
	 * @param ctx
	 */
	public DBAdapter(Context ctx)
	{
		this.context = ctx;
		this.DBHelper = new DatabaseHelper(this.context);
	}

	private static class DatabaseHelper extends SQLiteOpenHelper 
	{
		DatabaseHelper(Context context) 
		{
			super(context, DATABASE_NAME, null, DATABASE_VERSION);
		}

		@Override
		public void onCreate(SQLiteDatabase db) 
		{
			db.execSQL(CREATE_TABLE_PAZIENTI);
			db.execSQL(CREATE_TABLE_PROTOCOLLOA);
			db.execSQL(CREATE_TABLE_PROTOCOLLOB);
			db.execSQL(CREATE_TABLE_PROTOCOLLOC);
			db.execSQL(CREATE_TABLE_PROTOCOLLOD);
			db.execSQL(CREATE_TABLE_RILEVAZIONI);
			db.execSQL(CREATE_TABLE_PAZIENTI_CANCELLATI);
		}

		@Override
		public void onUpgrade(SQLiteDatabase db, int oldVersion, 
				int newVersion) 
		{               
			// Adding any table mods to this guy here
		}
	} 

	/**
	 * open the db
	 * @return this
	 * @throws SQLException
	 * return type: DBAdapter
	 */
	public DBAdapter open() throws SQLException 
	{
		this.db = this.DBHelper.getWritableDatabase();
		return this;
	}

	/**
	 * close the db 
	 * return type: void
	 */
	public void close() 
	{
		this.DBHelper.close();
	}
}