package prova.med.frag;

import java.util.List;

import prova.med.Ilisterners.IOnPazienteSelectedListener;
import prova.med.activities.ModificaPaziente;
import prova.med.activities.NuovaRilevazione;
import prova.med.activities.VisualizzaProtocollo;
import prova.med.boris.R;
import prova.med.db.PazientiDBAdapter;
import prova.med.listviewadapters.ArrayPazienteAdapter;
import prova.med.obj.Paziente;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.Fragment;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.view.ActionMode;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.AdapterView.OnItemLongClickListener;
import android.widget.ListView;
import android.widget.Toast;

public class PianoFrag extends Fragment {

	private List<Paziente> pazientilist = null;
	private Paziente paziente_selezionato = null;
	private PazientiDBAdapter datasource;
	private ArrayPazienteAdapter arraypazienteadapter ;
	private ActionMode mActionMode = null;
	private ListView listview;
	private IOnPazienteSelectedListener activitycallback;

	@Override
	public View onCreateView(LayoutInflater inflater,
			ViewGroup container, Bundle savedInstanceState) {
		/**
		 * Inflate the layout for this fragment
		 */

		View rootView = inflater.inflate(R.layout.tab_visualizza_pazienti, container, false);


		//Mostro i pazienti del piano

		datasource = new PazientiDBAdapter(getActivity().getApplicationContext());
		datasource.open();

		pazientilist = datasource.getAllPazienti(getTag());
		if(pazientilist.size() == 0)
			rootView.findViewById(R.id.textViewNessunPaziente).setVisibility(View.VISIBLE);
		else{
			listview = (ListView)rootView.findViewById(R.id.ListViewVisualizzaPazienti);
			arraypazienteadapter = new ArrayPazienteAdapter(getActivity().getBaseContext(), R.layout.rowpaziente, pazientilist);
			listview.setAdapter(arraypazienteadapter);


			//listener per click lungo su un paziente
			listview.setOnItemLongClickListener(new OnItemLongClickListener() {

				@Override
				public boolean onItemLongClick(AdapterView<?> adapter, View view, int position, long id) {

					paziente_selezionato = (Paziente) adapter.getItemAtPosition(position);
					mActionMode = getActivity().startActionMode(new ActionBarVisualizzaCallBack());
					return true;
				}
			});

			listview.setOnItemClickListener(new OnItemClickListener() {

				@Override
				public void onItemClick(AdapterView<?> adapter, View view, int position, long id) {
					paziente_selezionato = (Paziente) adapter.getItemAtPosition(position);
					activitycallback.onPazienteSelected(paziente_selezionato.getCodice_a_barre());

				}
			});

			rootView.findViewById(R.id.ListViewVisualizzaPazienti).setVisibility(View.VISIBLE);
		}



		datasource.close();
		return rootView;
	}

	public Paziente getPaziente_selezionato() {
		return paziente_selezionato;
	}

	//classe per il menu contestuale
	class ActionBarVisualizzaCallBack implements ActionMode.Callback {

		@Override
		public boolean onActionItemClicked(ActionMode mode, MenuItem item) {

			switch (item.getItemId()) {
			case R.id.aggiungirilevazioneVisualizza:
				if(getPaziente_selezionato() != null)
				{
					Intent intent = new Intent(getActivity(), NuovaRilevazione.class );
					intent.putExtra( getString(R.string.IntentCodBarre), getPaziente_selezionato().getCodice_a_barre());
					startActivity(intent);
					mode.finish();
				}
				return true;
			case R.id.editVisualizza:
				if(getPaziente_selezionato() != null)
				{
					Intent intent = new Intent(getActivity(), ModificaPaziente.class );
					intent.putExtra( getString(R.string.IntentPaziente), getPaziente_selezionato());
					startActivity(intent);
					mode.finish();
				}
				return true;
			case R.id.infoProtocolloVisualizza:
				if(getPaziente_selezionato() != null)
				{
					Intent intent = new Intent(getActivity(), VisualizzaProtocollo.class );
					intent.putExtra( getString(R.string.IntentCodBarre), getPaziente_selezionato().getCodice_a_barre());
					intent.putExtra( getString(R.string.IntentNomeProtocollo), getPaziente_selezionato().getNome_protocollo());
					startActivity(intent);
					mode.finish();
				}
				return true;
			case R.id.discardVisualizza:

				//visualizza dialog di conferma
				AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());
				builder.setMessage(getResources().getString(R.string.confermaCancellazione))
				.setCancelable(false)
				.setPositiveButton(getResources().getString(R.string.si), new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int id) {

						if(datasource.deletePaziente(getPaziente_selezionato().getCodice_a_barre()) ){
							Toast.makeText(getActivity(), "Cancellazione effettuata correttamente", Toast.LENGTH_SHORT).show();
							datasource.close();
							onResume();
						}
						else
							Toast.makeText(getActivity(), "Errore durante la cancellazione. Riprovare", Toast.LENGTH_SHORT).show();
					}
				})
				.setNegativeButton(getResources().getString(R.string.no), new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int id) {
						dialog.cancel();
					}
				});
				AlertDialog alert = builder.create();
				alert.show();
				mode.finish();
				return true;
			default: 
				return false;
			}

		}

		@Override
		public boolean onCreateActionMode(ActionMode mode, Menu menu) {
			// TODO Auto-generated method stub
			mode.getMenuInflater().inflate(R.menu.context_menu_visualizza, menu);
			return true;
		}

		@Override
		public void onDestroyActionMode(ActionMode mode) {
			mActionMode= null;
		}

		@Override
		public boolean onPrepareActionMode(ActionMode mode, Menu menu) {
			// TODO Auto-generated method stub
			mode.setTitle(paziente_selezionato.getCognome() + " " + paziente_selezionato.getNome());
			return false;
		}

	} 

	@Override
	public void onAttach(Activity activity) {
		super.onAttach(activity);

		// This makes sure that the container activity has implemented
		// the callback interface. If not, it throws an exception
		try {
			activitycallback = (IOnPazienteSelectedListener) activity;
		} catch (ClassCastException e) {
			throw new ClassCastException(activity.toString()
					+ " must implement IOnPazienteSelectedListener");
		}
	}
	@Override
	public void onResume() {
		datasource.open();
		pazientilist = datasource.getAllPazienti(getTag());
		if(pazientilist.size() != 0)
		{
			arraypazienteadapter = new ArrayPazienteAdapter(getActivity().getBaseContext(), R.layout.rowpaziente, pazientilist);
			listview.setAdapter(arraypazienteadapter);
			getView().findViewById(R.id.ListViewVisualizzaPazienti).setVisibility(View.VISIBLE);
			getView().findViewById(R.id.textViewNessunPaziente).setVisibility(View.GONE);
		}
		else
		{
			getView().findViewById(R.id.ListViewVisualizzaPazienti).setVisibility(View.GONE);
			getView().findViewById(R.id.textViewNessunPaziente).setVisibility(View.VISIBLE);
		}
		super.onResume();

	}

	@Override
	public void onPause() {
		datasource.close();
		super.onPause();
	}

}
