package prova.med.frag;

import prova.med.boris.R;
import prova.med.db.ProtocolloADBAdapter;
import prova.med.obj.*;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.Spinner;

public class ProtocolloAFrag extends AbstractProtocolloFrag {

	private ProtocolloADBAdapter datasource;
	private Spinner spinner_farmaco1;
	private Spinner spinner_posologia_farmaco1;
	private EditText editText_altrofarmaco;
	private Spinner spinner_posologia_farmaco2;
	private Spinner spinner_rescue;
	private Spinner spinner_posologia_rescue;
	private Spinner spinner_gastro;
	private EditText editText_dos_gastro;
	private Spinner spinner_ponv;
	private Spinner spinner_pos_ponv;
	private EditText editText_dos_ponv;

	@Override
	public View onCreateView(LayoutInflater inflater,
			ViewGroup container, Bundle savedInstanceState) {

		datasource = new ProtocolloADBAdapter(getActivity().getApplicationContext());
		datasource.open();
		/**
		 * Inflate the layout for this fragment
		 */
		View rootView = inflater.inflate(R.layout.tabprotocolloa, container, false);
		spinner_farmaco1 = (Spinner)rootView.findViewById(R.id.SpinnerFarmacoA1);
		spinner_posologia_farmaco1 = (Spinner)rootView.findViewById(R.id.SpinnerPosologiaFarmacoA1);
		editText_altrofarmaco = (EditText)rootView.findViewById(R.id.EditTextAltroFamacoA);
		spinner_posologia_farmaco2 = (Spinner)rootView.findViewById(R.id.SpinnerPosologiaFarmacoA2);
		spinner_rescue = (Spinner)rootView.findViewById(R.id.SpinnerRescueA);
		spinner_posologia_rescue = (Spinner)rootView.findViewById(R.id.SpinnerPosologiaRescueA);
		spinner_gastro = (Spinner) rootView.findViewById(R.id.SpinnerGastroprotezioneA);
		editText_dos_gastro = (EditText) rootView.findViewById(R.id.editTextDosaggioA1);
		spinner_ponv = (Spinner) rootView.findViewById(R.id.SpinnerPonvA);
		spinner_pos_ponv =  (Spinner)rootView.findViewById(R.id.SpinnerposologiaalinA);
		editText_dos_ponv = (EditText)rootView.findViewById(R.id.editTextDosaggioA2);
		return rootView;
	}


	@Override
	public String checkFields() {
		if( (!spinner_farmaco1.getSelectedItem().toString().equals("-")) && spinner_posologia_farmaco1.getSelectedItem().toString().equals("-") )
			return "Primo farmaco: dosaggio mancante";
		if( (!editText_altrofarmaco.getText().toString().trim().isEmpty()) && spinner_posologia_farmaco2.getSelectedItem().toString().equals("-") )
			return "Secondo farmaco: dosaggio mancante";
		if( (!spinner_gastro.getSelectedItem().toString().equals("-")) && editText_dos_gastro.getText().toString().trim().isEmpty() )
			return "Gastroprotezione: dosaggio mancante";
		if( (!spinner_ponv.getSelectedItem().toString().equals("-")) && editText_dos_ponv.getText().toString().trim().isEmpty() )
			return "Ponv: dosaggio mancante";
		return SUCCESS;
	}

	@Override
	public AbstractProtocollo createProtocol()
	{
		ProtocolloA p = new ProtocolloA();
		p.setFarmacopos1(new FarmacoPos( spinner_farmaco1.getSelectedItem().toString(), spinner_posologia_farmaco1.getSelectedItem().toString() ));
		p.setFarmacopos2(new FarmacoPos( editText_altrofarmaco.getText().toString(), spinner_posologia_farmaco2.getSelectedItem().toString() ));
		p.setRescue(new Rescue( spinner_rescue.getSelectedItem().toString(), spinner_posologia_rescue.getSelectedItem().toString() ));
		p.setGastro(new Gastroprotezione( spinner_gastro.getSelectedItem().toString(), editText_dos_gastro.getText().toString() ));
		p.setPonv(new Ponv( spinner_ponv.getSelectedItem().toString(), spinner_pos_ponv.getSelectedItem().toString() , editText_dos_ponv.getText().toString() ));
		return p;

	}

	@Override
	public boolean savePazienteProtocollo(Paziente paziente, AbstractProtocollo prot) {

		return datasource.createPazienteAndProtocollo(paziente, prot);
	}

	@Override
	public void onResume() {
		datasource.open();
		super.onResume();
	}

	@Override
	public void onPause() {
		datasource.close();
		super.onPause();
	}

}


