package prova.med.frag;

import android.graphics.Color;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.View.OnClickListener;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;
import prova.med.boris.R;
import prova.med.db.ProtocolloCDBAdapter;
import prova.med.obj.*;
public class ProtocolloCFrag extends AbstractProtocolloFrag {

	private ProtocolloCDBAdapter datasource;
	private EditText editText_dos_farmaco1;
	private EditText editText_farmaco2;
	private EditText editText_dos_farmaco2;
	private EditText editText_solfisio;
	private EditText editText_volumetotale;
	private EditText editText_infusionecontinua;
	private EditText editText_dosebolo;
	private EditText editText_tempoblocco;
	private EditText editText_limite4ore;
	private EditText editText_dosetotale;
	private CheckBox checkbox_paracetamolo;
	private TextView textView_paracetamolo;
	private Spinner spinner_rescue;
	private Spinner spinner_posologia_rescue;
	private Spinner spinner_gastro;
	private EditText editText_dos_gastro;
	private Spinner spinner_ponv;
	private Spinner spinner_pos_ponv;
	private EditText editText_dos_ponv;

	@Override
	public View onCreateView(LayoutInflater inflater,
			ViewGroup container, Bundle savedInstanceState) {
		/**
		 * Inflate the layout for this fragment
		 */
		datasource = new ProtocolloCDBAdapter(getActivity().getApplicationContext());
		datasource.open();

		View rootView = inflater.inflate(R.layout.tabprotocolloc, container, false);

		editText_dos_farmaco1 = (EditText)rootView.findViewById(R.id.EditTextDosaggioC1);
		editText_farmaco2 = (EditText) rootView.findViewById(R.id.EditTextFarmacoC2);
		editText_dos_farmaco2 = (EditText)rootView.findViewById(R.id.EditTextDosaggioC2);
		editText_solfisio = (EditText)rootView.findViewById(R.id.EditTextDosaggioSolFisioC);
		editText_volumetotale = (EditText)rootView.findViewById(R.id.EditTextDosaggioVolumeTotaleC);
		editText_infusionecontinua = (EditText)rootView.findViewById(R.id.editTextInfusioneContinuaC);
		editText_dosebolo = (EditText)rootView.findViewById(R.id.editTextDoseBoloC);
		editText_tempoblocco = (EditText)rootView.findViewById(R.id.EditTextTempoBloccoC);
		editText_limite4ore = (EditText)rootView.findViewById(R.id.EditTextLimiteC);
		editText_dosetotale = (EditText)rootView.findViewById(R.id.EditTextDoseTotaleC);
		
		checkbox_paracetamolo=(CheckBox)rootView.findViewById(R.id.checkBoxIntegraParacetamoloC);
		checkbox_paracetamolo.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {

				if(((CheckBox)v).isChecked())
					textView_paracetamolo.setTextColor(Color.BLACK);
				else
					textView_paracetamolo.setTextColor(Color.GRAY);
			}
		});

		spinner_rescue = (Spinner)rootView.findViewById(R.id.SpinnerRescueC);
		spinner_posologia_rescue = (Spinner)rootView.findViewById(R.id.SpinnerPosologiaRescueC);

		spinner_gastro = (Spinner) rootView.findViewById(R.id.SpinnerGastroprotezioneC);
		editText_dos_gastro = (EditText) rootView.findViewById(R.id.EditTextDosaggioGastroC);
		spinner_ponv = (Spinner) rootView.findViewById(R.id.SpinnerPonvC);
		spinner_pos_ponv =  (Spinner)rootView.findViewById(R.id.SpinnerposologiaalinC);
		editText_dos_ponv = (EditText)rootView.findViewById(R.id.EditTextDosaggioPonvC);
		return rootView;
	}

	@Override
	public String checkFields() {
		if( editText_dos_farmaco1.getText().toString().trim().isEmpty() )
			return "Primo farmaco: dosaggio mancante";
		if( (!editText_farmaco2.getText().toString().trim().isEmpty()) && editText_dos_farmaco2.getText().toString().trim().isEmpty() )
			return "Secondo farmaco: dosaggio mancante";
		if( editText_solfisio.getText().toString().trim().isEmpty() )
			return "Soluzione fisiologica mancante";
		if( editText_volumetotale.getText().toString().trim().isEmpty() )
			return "Volume totale mancante";
		if( editText_infusionecontinua.getText().toString().trim().isEmpty() )
			return "Infusione continua mancante";
		if( editText_dosebolo.getText().toString().trim().isEmpty() )
			return "Dose Bolo mancante";
		if( editText_tempoblocco.getText().toString().trim().isEmpty() )
			return "Tempo Blocco mancante";
		if( editText_limite4ore.getText().toString().trim().isEmpty() )
			return "Limite 4 ore mancante";
		if( editText_dosetotale.getText().toString().trim().isEmpty() )
			return "Dose Totale mancante";
		if( (!spinner_gastro.getSelectedItem().toString().equals("-")) && editText_dos_gastro.getText().toString().trim().isEmpty() )
			return "Gastroprotezione: dosaggio mancante";
		if( (!spinner_ponv.getSelectedItem().toString().equals("-")) && editText_dos_ponv.getText().toString().trim().isEmpty() )
			return "Ponv: dosaggio mancante";
		return SUCCESS;
	}
	
	@Override
	public AbstractProtocollo createProtocol()
	{
		ProtocolloC p = new ProtocolloC();
		
		p.setFarmaco(new FarmacoDos( ((Spinner)getView().findViewById(R.id.SpinnerFarmacoC1)).getSelectedItem().toString(), editText_dos_farmaco1.getText().toString() ));
		p.setAltro_farmaco(new FarmacoDos( editText_farmaco2.getText().toString(), editText_dos_farmaco2.getText().toString() ));

		p.setSol_fisiologica( editText_solfisio.getText().toString() );
		p.setVolume_totale( editText_volumetotale.getText().toString() );
		p.setInfusione_continua(editText_infusionecontinua.getText().toString() );
		p.setDose_bolo( editText_dosebolo.getText().toString() );
		p.setTempo_blocco( editText_tempoblocco.getText().toString() );
		p.setLimite_ore( editText_limite4ore.getText().toString() );
		p.setDose_totale( editText_dosetotale.getText().toString() );

		p.setIntegra_paracetamolo(checkbox_paracetamolo.isChecked());
		p.setGastro(new Gastroprotezione( spinner_gastro.getSelectedItem().toString(), editText_dos_gastro.getText().toString() ));
		p.setPonv(new Ponv( spinner_ponv.getSelectedItem().toString(), spinner_pos_ponv.getSelectedItem().toString() ,editText_dos_ponv.getText().toString() ));

		p.setRescue(new Rescue( spinner_rescue.getSelectedItem().toString(),  spinner_posologia_rescue.getSelectedItem().toString() ));
		return p;
	}

	@Override
	public boolean savePazienteProtocollo(Paziente paziente, AbstractProtocollo prot) {

		return datasource.createPazienteAndProtocollo(paziente, prot);
	}

	@Override
	public void onResume() {
		datasource.open();
		super.onResume();
	}

	@Override
	public void onPause() {
		datasource.close();
		super.onPause();
	}

}


