package prova.med.listviewadapters;

import java.util.List;

import prova.med.boris.R;
import prova.med.obj.Rilevazione;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

public class ArrayRilevazioneAdapter extends ArrayAdapter<Rilevazione>{


	public ArrayRilevazioneAdapter(Context context, int resource, List<Rilevazione> objects) 
	{
		super(context, resource, objects);
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		LayoutInflater inflater = (LayoutInflater) getContext().getSystemService(Context.LAYOUT_INFLATER_SERVICE);
		convertView = inflater.inflate(R.layout.rowrilevazione, null);
		TextView data = (TextView)convertView.findViewById(R.id.textViewData);
		TextView ora = (TextView)convertView.findViewById(R.id.textViewOra);
		TextView svs_rip = (TextView)convertView.findViewById(R.id.textViewSVSriposovalue);
		TextView svs_sfo = (TextView)convertView.findViewById(R.id.textViewSVSsforzovalue);
		TextView vas_rip = (TextView)convertView.findViewById(R.id.textViewVASriposovalue);
		TextView vas_sfo = (TextView)convertView.findViewById(R.id.textViewVASsforzovalue);
		TextView sede = (TextView)convertView.findViewById(R.id.textViewSedevalue);
		TextView sedazione = (TextView)convertView.findViewById(R.id.textViewSedazionevalue);
		TextView fr = (TextView)convertView.findViewById(R.id.textViewfrvalue);
		TextView so2 = (TextView)convertView.findViewById(R.id.textViewso2value);
		TextView pa = (TextView)convertView.findViewById(R.id.textViewpavalue);
		TextView fc = (TextView)convertView.findViewById(R.id.textViewfcvalue);
		
		Rilevazione r = getItem(position);
		data.setText(r.getData());
		ora.setText(r.getOra());
		svs_rip.setText(r.getSvs_riposo() + "");
		svs_sfo.setText(r.getSvs_sforzo() + "");
		vas_rip.setText( r.getVas_riposo() + "");
		vas_sfo.setText(r.getVas_sforzo() + "");
		sede.setText(r.getSede() + "");
		sedazione.setText(r.getSedazione() + "");
		fr.setText(r.getFr() + "");
		so2.setText(r.getSo2() + "");
		pa.setText(r.getPa() + "");
		fc.setText(r.getFc() + "");
		
		if(!r.getEffetti_avversi().isEmpty())
		{
			LinearLayout layouteffetti = (LinearLayout)convertView.findViewById(R.id.LinearLayoutEffettiAvversi);
			TextView effetti_avversi = (TextView)convertView.findViewById(R.id.textViewEffettiAvversivalue);
			effetti_avversi.setText(r.getEffetti_avversi());
			layouteffetti.setVisibility(View.VISIBLE);
		}
		if(!r.getNote().isEmpty())
		{
			LinearLayout layoutnote = (LinearLayout)convertView.findViewById(R.id.LinearLayoutNote);
			TextView note = (TextView)convertView.findViewById(R.id.textViewNotevalue);
			note.setText(r.getNote());
			layoutnote.setVisibility(View.VISIBLE);
		}
		return convertView;
	}

}
