package prova.med.obj;

import java.io.Serializable;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;


public class Rilevazione implements Comparable<Rilevazione>, Serializable{

	//public static final String RIPOSO = "riposo";
	//public static final String SFORZO = "sforzo";


	/**
	 * 
	 */
	private static final long serialVersionUID = -6711522291098533808L;
	
	private String data;
	private String ora;
	private int svs_riposo;	//1 to 5

	private int svs_sforzo; //1 to 5
	private int vas_riposo;	//0 to 10
	private int vas_sforzo;	//0 to 10
	private int sede;	//1 to 3
	private int sedazione;	//1 to 5
	private int fr;
	private int so2;
	private int pa;
	private int fc;
	private String effetti_avversi;

	private String note;

	public static final String format_data = "dd/MM/yyyy";
	public static final String format_ora = "HH:mm";

	public Rilevazione()
	{
	}

	public Rilevazione(String data, String orario)
	{
		this.data = data;
		this.ora = orario;
	}
	public String getData() {
		return data;
	}
	public void setData(String giorno) {
		this.data = giorno;
	}
	public String getOra() {
		return ora;
	}
	public void setOra(String orario) {
		this.ora = orario;
	}
	public int getSvs_riposo() {
		return svs_riposo;
	}

	public void setSvs_riposo(int svs_riposo) {
		this.svs_riposo = svs_riposo;
	}

	public int getSvs_sforzo() {
		return svs_sforzo;
	}

	public void setSvs_sforzo(int svs_sforzo) {
		this.svs_sforzo = svs_sforzo;
	}

	public int getVas_riposo() {
		return vas_riposo;
	}

	public void setVas_riposo(int vas_riposo) {
		this.vas_riposo = vas_riposo;
	}

	public int getVas_sforzo() {
		return vas_sforzo;
	}

	public void setVas_sforzo(int vas_sforzo) {
		this.vas_sforzo = vas_sforzo;
	}
	public int getSede() {
		return sede;
	}
	public void setSede(int sede) {
		this.sede = sede;
	}
	public int getSedazione() {
		return sedazione;
	}
	public void setSedazione(int sedazione) {
		this.sedazione = sedazione;
	}
	public int getFr() {
		return fr;
	}

	public void setFr(int fr) {
		this.fr = fr;
	}

	public int getSo2() {
		return so2;
	}

	public void setSo2(int so2) {
		this.so2 = so2;
	}

	public int getPa() {
		return pa;
	}

	public void setPa(int pa) {
		this.pa = pa;
	}

	public int getFc() {
		return fc;
	}

	public void setFc(int fc) {
		this.fc = fc;
	}
	public String getEffetti_avversi() {
		return effetti_avversi;
	}

	public void setEffetti_avversi(String effetti_avversi) {
		this.effetti_avversi = effetti_avversi;
	}
	public String getNote() {
		return note;
	}
	public void setNote(String note) {
		this.note = note;
	}

	@Override
	public int compareTo(Rilevazione other)
	{
		SimpleDateFormat formatter = new SimpleDateFormat(format_data + " " + format_ora , Locale.getDefault());
		if(other != null)
		{
			try {
				Date data1 = formatter.parse(this.getData() + " " + this.getOra());
				Date data2 = formatter.parse(other.getData() + " " + other.getOra());
				return data1.compareTo(data2);
			} catch (ParseException e) {
				return 0;
			}

		}
		else
			return 0;
	}
}
